﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GraphicsBoxCCharpSample
{
    public partial class Form1 : Form
    {
        private int YOffset;

        public Form1()
        {
            InitializeComponent();
        }

        private void graphicsBox1_Click(object sender, EventArgs e)
        {
            YOffset = graphicsBox1.Height / 2;
            // GraphicBoxにフォーカスする。
            // Focus()をしないとMouseWheeledイベントが発生しない。
            graphicsBox1.Focus();
        }

        private void graphicsBox1_MouseWheeled(object sender, MouseEventArgs e)
        {
            YOffset -= e.Delta;

            // クリア
            graphicsBox1.Graphics.Clear(graphicsBox1.BackColor);

            // GraphicsBoxのGraphicsプロパティより取得
            Graphics g = graphicsBox1.Graphics;
            // GraphicsBoxのFontsプロパティで設定したフォント
            Font f = graphicsBox1.Fonts;        

            for (int i = -20; i < 20; i++)
            {
                // 線の描画
                g.DrawLine(
                    Pens.Red,
                    0, 
                    YOffset + i * 10, 
                    graphicsBox1.Width, 
                    YOffset + i * 10);

                // 文字の描画
                g.DrawString(
                    i.ToString(), 
                    f,
                    Brushes.Blue, 
                    (i + 20) * 20, 
                    YOffset + i * 10);
            }
            // 描画更新
            graphicsBox1.Invalidate();
        }

    }
}
